package com.adamatomic.Mode
{
	import flash.display.BitmapData;
	import org.flixel.*;
	import __AS3__.vec.Vector;

	public class MenuState extends FlxState
	{
		[Embed(source = "../../../data/blip.mp3")] public static var SndBlip:Class;
		[Embed(source = '../../../data/story.txt', mimeType = "application/octet-stream")] public static var TxtStory:Class;		
		
		private var _story:Array;
		private var _storypos:Number;

		private var _ticketDisplay:FlxText;
		private var _textArray:Vector.<FlxText>;

		private const _bloom:uint = 2;	//How much light bloom to have - larger numbers = more
		private var _fx:FlxSprite;		//Our helper sprite - basically a mini screen buffer (see below)
		private var _t:Number;

		private var _promptLayer:FlxGroup;
		private var _promptText:FlxText;
		private var _promptBG:FlxSprite;
		private var _prompting:Boolean;
		private var _timedprompting:Boolean;
		
		private const m:Number = 60;
		private const h:Number = 60 * m;
		
		private const _dialogue:Array = [
			[2 * h + 1 * m + 1, "hello"]
			];

		override public function create():void
		{
			var i:uint;
			var j:uint;
			var s:FlxSprite;
			_t = 0;
			
			_prompting = false;
			_timedprompting = false;
			
			//This is the sprite we're going to use to help with the light bloom effect
			//First, we're going to initialize it to be a fraction of the screens size
			_fx = new FlxSprite();
			_fx.createGraphic(FlxG.width/_bloom,FlxG.height/_bloom,0,true);
			_fx.origin.x = _fx.origin.y = 0;	//Zero the origin so scaling goes from top-left not center
			_fx.scale.x = _fx.scale.y = _bloom;	//Scale it up to be the same size as the screen again
			_fx.antialiasing = true;			//Set AA to true for maximum blurry
			_fx.color = 0xffffff;				//Tint it a little, cuz that looks cool
			_fx.blend = "screen";				//Finally, set blend mode to "screen" (important!)
			//Note that we do not add it to the game state!  It's just a helper, not a real sprite.
		
			var str:String;
			str = new TxtStory;
			_story = str.split("\n");
			_storypos = -1;

						
			screen.scale.x = screen.scale.y = 1/_bloom;
			
			FlxG.mouse.hide();
			
			_ticketDisplay = new FlxText(margin, ymargin, FlxG.width, "225");
			_ticketDisplay.color = 0xffff0000;
			_ticketDisplay.alignment = "center";
			_ticketDisplay.visible = false;
			this.add(_ticketDisplay);
			
			_textArray = new Vector.<FlxText>();
			for (i = 1; i+1 < FlxG.height / 10; i++)
			{
				const margin:Number = 2;
				const ymargin:Number = 3;
				var t:FlxText;
				t = new FlxText(margin, ymargin + i * 10, FlxG.width, "");
				t.size = 8;
				t.color = 0xffa4f39b;
				t.antialiasing = true;
				_textArray.push(t);
				add(t);
			}
			
			addLine("",0x88ffee);
			addLine("",0x79f385);
			addLine("", 0xff005f);
			
			
			_promptLayer = new FlxGroup();
			const xoff:Number = 10;
			const yoff:Number = 10;
			
			var bd:BitmapData = new BitmapData(100, 16, true, 0xff000000);
			for (i = 0; i < bd.width; i++)
			{
				for (j = 0; j < bd.height; j++)
				{
					if (i == 0 || j == 0||i==bd.width-1||j==bd.height-1)
						bd.setPixel(i,j,0xffffffff);
				}
			}
			
			_promptBG = new FlxSprite(xoff, yoff);
			_promptBG.pixels = bd;
			_promptBG.width = bd.width;
			_promptBG.height = bd.height;
			
			_promptBG.x = FlxG.width / 2 - _promptBG.width / 2;
			_promptBG.y = FlxG.height / 2 - _promptBG.height / 2;
			
			_promptLayer.add(_promptBG);
			
			_promptText = new FlxText(xoff, yoff, _promptBG.width, "press X");
			_promptText.alignment = "center";
			_promptText.x = _promptBG.x;
			_promptText.y = _promptBG.y + 1;
			
			_promptLayer.add(_promptText);
			_promptLayer.visible=false;
			
			this.add(_promptLayer);
		}
		
		override public function update():void
		{
			super.update();
		
			if (!_prompting)
				_t += FlxG.elapsed;
			else
			{
				if (FlxG.keys.justPressed("X"))
				{
					_promptLayer.visible = false;
					FlxG.play(SndBlip);
					_prompting = false;
				}
			}
			
			if (_t > 3)
			{
				_t = 0;
				_storypos++;
				
				if (_storypos < _story.length)
				{
					var strHelper:StringHelper = new StringHelper();
					
					var str:String = _story[_storypos]; 
					trace(str);
					if (str.charAt(0) == "|")
					{
						str = str.slice(1);
						if (str.length > 0)
						{
							_ticketDisplay.text = str;
							_ticketDisplay.visible = true;
							FlxG.play(SndBlip);
						}
						else
						{
							_ticketDisplay.text = str;
							_ticketDisplay.visible = false;
						}
					}
					else if (str.search("PROMPT")>=0)
					{
						_prompting = true;
						_promptLayer.visible = true;
					}
					else
					{
						if (str.charAt(0) == '\"')
						{
							addLine(str, 0xffff00);							
						}
						else
						{
							addLine(str, 0xffffff);
						}
					}
				}
			}
			
			switch (int(_t * 2)%10)
			{
				case 0:
				_fx.color = 0xffffff;
				break;
				case 1:
				_fx.color = 0xefefef;
				break;
				case 2:
				_fx.color = 0xdfdfdf;
				break;
				case 3:
				_fx.color = 0xcfcfcf;
				break;
				case 4:
				_fx.color = 0xbfbfbf;
				break;				
				case 5:
				_fx.color = 0xafafaf;
				break;				
				case 6:
				_fx.color = 0xbfbfbf;
				break;				
				case 7:
				_fx.color = 0xcfcfcf;
				break;				
				case 8:
				_fx.color = 0xdfdfdf;
				break;				
				case 9:
				_fx.color = 0xefefef;
				break;				
			}

		}
		
		private function addLine(s:String,c:uint):void
		{
			for (var i:int = 0; i <_textArray.length-1 ; i++)
			{
				_textArray[i].text = _textArray[i + 1].text;
				_textArray[i].color = _textArray[i + 1].color;
			}
			
			_textArray[_textArray.length - 1].text = s;
			_textArray[_textArray.length - 1].color = c;
		}

		override public function postProcess():void
		{
			//The actual blur process is quite simple now.
			//First we draw the contents of the screen onto the tiny FX buffer:
			_fx.draw(screen);
			//Then we draw the scaled-up contents of the FX buffer back onto the screen:
			screen.draw(_fx);
		}
	}
}

class StringHelper {
    public function StringHelper() {
    }

    public function replace(str:String, oldSubStr:String, newSubStr:String):String {
        return str.split(oldSubStr).join(newSubStr);
    }

    public function trim(str:String, char:String):String {
        return trimBack(trimFront(str, char), char);
    }

    public function trimFront(str:String, char:String):String {
        char = stringToCharacter(char);
        if (str.charAt(0) == char) {
            str = trimFront(str.substring(1), char);
        }
        return str;
    }

    public function trimBack(str:String, char:String):String {
        char = stringToCharacter(char);
        if (str.charAt(str.length - 1) == char) {
            str = trimBack(str.substring(0, str.length - 1), char);
        }
        return str;
    }

    public function stringToCharacter(str:String):String {
        if (str.length == 1) {
            return str;
        }
        return str.slice(0, 1);
    }
}
